﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

namespace StarFashion
{
    public partial class FormMultipleItems : Form
    {
        public FormMultipleItems()
        {
            InitializeComponent();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnAddItems_Click(object sender, EventArgs e)
        {
            if (ValidateControls())
                SubmitChanges();
        }

        private void SubmitChanges()
        {
            SqlCommand command;
            string statement = string.Empty;
            string codeList = string.Empty;
            foreach (Control p in mainPanel.Controls)
            {
                //make sure it is a FlowLayoutPanel
                if (p is FlowLayoutPanel)
                {
                    try
                    {
                        string code = ((TextBox)p.Controls.Find("_txtCode", true)[0]).Text;
                        statement = string.Format("insert into Item(Code, BrandName, Size, Color, Description, DateInventoried, TypeId, Cost) " +
                            "values('{0}','{1}','{2}','{3}','{4}','{5}',{6},{7})",
                            code,
                            ((TextBox)p.Controls.Find("_txtBrandName", true)[0]).Text,
                            ((TextBox)p.Controls.Find("_txtSize", true)[0]).Text,
                            ((TextBox)p.Controls.Find("_txtColor", true)[0]).Text,
                            "", //TODO: not sure if we want to add generic description here
                            DateTime.Now,
                            ((ComboBox)p.Controls.Find("_txtColor", true)[0]).SelectedIndex,
                            ((TextBox)p.Controls.Find("_txtCost", true)[0]).Text);
                        command = new SqlCommand();
                        string connString = ConfigurationManager.ConnectionStrings["StarFashion.Properties.Settings.StarFashionConnectionString"].ConnectionString;
                        command.Connection = new SqlConnection(connString);
                        command.Connection.Open();
                        command.CommandText = statement;
                        int rowsAffected = command.ExecuteNonQuery();
                        if (rowsAffected != 1)
                            MessageBox.Show("Item " + code + " not inserted!", "StarFashion");
                        else
                            codeList += code + Environment.NewLine;
                        command.Connection.Close();
                        
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Could not insert the item because of the following exception: " +
                            ex.Message, "StarFashion");
                    }
                }
            }
            MessageBox.Show("The Items with code " + Environment.NewLine + codeList + Environment.NewLine +
                            " were added to the inventory", "StarFashion");
        }

        private bool ValidateControls()
        {
            throw new NotImplementedException();
        }

        private void FormMultipleItems_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'starFashionDataSet3.ItemType' table. You can move, or remove it, as needed.
            this.itemTypeTableAdapter.Fill(this.starFashionDataSet3.ItemType);
            cbItemName.SelectedIndex = 0;
        }

        private void btnCancelItems_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnCreateList_Click(object sender, EventArgs e)
        {
            //Clear the panel first
            mainPanel.Controls.Clear();
            
            int itemsToAdd = int.Parse(cmbItemCount.SelectedItem.ToString());
            mainPanel.RowStyles.Add(new RowStyle(SizeType.AutoSize));
            for (int i = 0; i < itemsToAdd; i++)
            {

                //Create a panel for each item that contains all the controls
                //Add the panel to a row of the table
                //Display the table panel on the window
                FlowLayoutPanel itemPanel = new FlowLayoutPanel();
                //itemPanel.Dock = DockStyle.Fill;
                //itemPanel.Width = mainPanel.Width;
                itemPanel.AutoSize = true;
                if (i % 2 == 0)
                    itemPanel.BackColor = System.Drawing.Color.FromArgb(255, 224, 192);
                else
                    itemPanel.BackColor = System.Drawing.Color.FromArgb(255, 192, 128);
                //itemPanel.AutoScroll = true;


                //Code
                Label _lblCode = new Label();
                _lblCode.Text = "Code:";
                TextBox _txtCode = new TextBox();
                if (cbGenerateId.Checked)
                    _txtCode.Text = Guid.NewGuid().ToString();
                else
                    _txtCode.Text = txtCode.Text;
                //Brand
                Label _lblBrand = new Label();
                _lblBrand.Text = "Brand:";
                TextBox _txtBrandName = new TextBox();
                _txtBrandName.Text = txtBrandName.Text;

                //Item Name
                Label _lblItemName = new Label();
                _lblItemName.Text = "Item Name:";
                ComboBox _cbItemName = new ComboBox();

                for (int j = 0; j < cbItemName.Items.Count; j++)
                    _cbItemName.Items.Add(cbItemName.Items[j]);
                _cbItemName.SelectedItem = cbItemName.SelectedItem;

                //Size
                Label _lblSize = new Label();
                _lblSize.Text = "Size:";
                TextBox _txtSize = new TextBox();
                _txtSize.Text = txtSize.Text;

                //Color
                Label _lblColor = new Label();
                _lblColor.Text = "Color:";
                TextBox _txtColor = new TextBox();
                _txtColor.Text = txtColor.Text;

                //Cost
                Label _lblCost = new Label();
                _lblCost.Text = "Cost:";
                TextBox _txtCost = new TextBox();
                _txtCost.Text = txtCost.Text;

                itemPanel.Controls.Clear();

                itemPanel.Controls.Add(_lblCode);
                itemPanel.Controls.Add(_txtCode);
                itemPanel.Controls.Add(_lblBrand);
                itemPanel.Controls.Add(_txtBrandName);
                itemPanel.Controls.Add(_lblItemName);
                itemPanel.Controls.Add(_cbItemName);
                itemPanel.Controls.Add(_lblSize);
                itemPanel.Controls.Add(_txtSize);

                itemPanel.Controls.Add(_lblColor);
                itemPanel.Controls.Add(_txtColor);
                itemPanel.Controls.Add(_lblCost);
                itemPanel.Controls.Add(_txtCost);

                mainPanel.Controls.Add(itemPanel,0,i);
            }
            
        }

        private void cbGenerateId_CheckedChanged(object sender, EventArgs e)
        {
            if (cbGenerateId.Checked)
                txtCode.Enabled = false;
            else
                txtCode.Enabled = true;
        }
    }
}
