﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

namespace StarFashion
{
    public partial class UpdateItem : Form
    {
        private DataGridViewRow rowToEdit;

        public UpdateItem(DataGridViewRow row)
        {
            InitializeComponent();
            rowToEdit = row;
        }

        private void UpdateItem_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'starFashionDataSet2.ItemType' table. You can move, or remove it, as needed.
            this.itemTypeTableAdapter.Fill(this.starFashionDataSet2.ItemType);
            InitializeControls();
        }

        private void InitializeControls()
        {
            //TODO: I am picking the cells here by index. I got an error
            //      when I tried to retrieve them by name. This means any
            //      changes you make to the order of the columns will affect this.
            txtEditCode.Text = rowToEdit.Cells[0].Value.ToString();
            txtEditBrandName.Text = rowToEdit.Cells[1].Value.ToString();
            cmbEditItemName.Text = rowToEdit.Cells[2].Value.ToString();
            txtEditSize.Text = rowToEdit.Cells[3].Value.ToString();
            txtEditColor.Text = rowToEdit.Cells[4].Value.ToString();
            txtEditDescription.Text = rowToEdit.Cells[5].Value.ToString();
            dtEditInventoried.Value = (DateTime)rowToEdit.Cells[6].Value;
            DateTime dtTemp;
            bool result = DateTime.TryParse(rowToEdit.Cells[7].Value.ToString(), out dtTemp);
            if (dtTemp == DateTime.MinValue)
            {
                cbSold.Checked = false;
                lblDateSold.Visible = false;
                dtEditSold.Visible = false;
            }
            else
            {
                cbSold.Checked = true;
                lblDateSold.Visible = true;
                dtEditSold.Visible = true;
                dtEditSold.Value = dtTemp;
            }
            txtEditCost.Text = rowToEdit.Cells[8].Value.ToString();
            txtEditPrice.Text = rowToEdit.Cells[9].Value.ToString();
            bool blTemp;
            result = Boolean.TryParse(rowToEdit.Cells[10].Value.ToString(), out blTemp);
            cbSoldButNotPaid.Checked = blTemp;
            result = Boolean.TryParse(rowToEdit.Cells[11].Value.ToString(), out blTemp);
            cbCheckedOut.Checked = blTemp;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnApplyChanges_Click(object sender, EventArgs e)
        {
            if (ValidateControls())
                SubmitChanges();
        }

        private void SubmitChanges()
        {
            SqlCommand command;
            string statement = string.Empty;

            try
            {
                DateTime? dtSoldDate = null;
                if (cbSold.Checked)  dtSoldDate = dtEditSold.Value;
                statement = string.Format("update Item set BrandName = '{0}', Size = '{1}', Color = '{2}', " +
                    " Description = '{3}', DateInventoried = '{4}', TypeId = {5}, Cost = {6}, Price = {7}, " +
                    " SoldButNotPaid = {8}, CheckedOut = {9} ", 
                        txtEditBrandName.Text,
                        txtEditSize.Text,
                        txtEditColor.Text,
                        txtEditDescription.Text,
                        dtEditInventoried.Value,
                        cmbEditItemName.SelectedIndex,
                        (txtEditCost.Text != "") ? double.Parse(txtEditCost.Text) : 0.00f,
                        (txtEditPrice.Text != "") ? double.Parse(txtEditPrice.Text) : 0.00f,
                        ((cbSoldButNotPaid.Checked) ? 1 : 0),
                        ((cbCheckedOut.Checked) ? 1 : 0));
                if (cbSold.Checked)
                    statement += string.Format(", DateSold = '{0}'", dtSoldDate);
                statement += string.Format(" where Code = '{0}'", txtEditCode.Text);
                command = new SqlCommand();
                string connString = ConfigurationManager.ConnectionStrings["StarFashion.Properties.Settings.StarFashionConnectionString"].ConnectionString;
                command.Connection = new SqlConnection(connString);
                command.Connection.Open();
                command.CommandText = statement;
                int rowsAffected = command.ExecuteNonQuery();
                command.Connection.Close();
                MessageBox.Show("The Item with code " + txtEditCode.Text +
                    " has been updated", "StarFashion");
                this.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Could not update the item because of the following exception: " +
                    ex.Message, "StarFashion");
            }
        }

        private bool ValidateControls()
        {
            if (txtEditBrandName.Text.Length <= 0)
            {
                MessageBox.Show("Please enter the brand name", "StarFashion");
                txtEditBrandName.BackColor = Color.Yellow;
                txtEditBrandName.Focus();
                return false;
            }
            else
                txtEditBrandName.BackColor = Color.White;

            if (cmbEditItemName.SelectedIndex <= 0)
            {
                MessageBox.Show("Please select the item name", "StarFashion");
                cmbEditItemName.BackColor = Color.Yellow;
                cmbEditItemName.Focus();
                return false;
            }
            else
                cmbEditItemName.BackColor = Color.White;

            if (txtEditSize.Text.Length <= 0)
            {
                MessageBox.Show("Please enter the size", "StarFashion");
                txtEditSize.BackColor = Color.Yellow;
                txtEditSize.Focus();
                return false;
            }
            else
                txtEditSize.BackColor = Color.White;

            if (txtEditColor.Text.Length <= 0)
            {
                MessageBox.Show("Please enter the color", "StarFashion");
                txtEditColor.BackColor = Color.Yellow;
                txtEditColor.Focus();
                return false;
            }
            else
                txtEditColor.BackColor = Color.White;

            if (txtEditCost.Text.Length <= 0)
            {
                MessageBox.Show("Please enter the cost", "StarFashion");
                txtEditCost.BackColor = Color.Yellow;
                txtEditCost.Focus();
                return false;
            }
            else
                txtEditCost.BackColor = Color.White;

            //Cannot check here because he might not be updating the price
            //if (txtEditPrice.Text.Length <= 0)
            //{
            //    MessageBox.Show("Please enter the price", "StarFashion");
            //    txtEditPrice.BackColor = Color.Yellow;
            //    txtEditPrice.Focus();
            //    return false;
            //}
            //else
            //    txtEditPrice.BackColor = Color.White;

            //The item cannot be "sold but not paid" or "checked out", and yet has a price
            double price = 0;
            if (txtEditPrice.Text != "")
                price = double.Parse(txtEditPrice.Text);
                
            if (price > 0 &&
                ((cbSoldButNotPaid.Checked) || (cbCheckedOut.Checked)))
            {
                MessageBox.Show("Item cannot be checked out or sold and not paid and yet has a price!", "StarFashion");
                return false;
            }

            return true;
        }

        private void cbSold_CheckedChanged(object sender, EventArgs e)
        {
            if (cbSold.Checked)
            {
                lblDateSold.Visible = true;
                dtEditSold.Visible = true;
            }
            else
            {
                lblDateSold.Visible = false;
                dtEditSold.Visible = false;
            }
        }

    }
}
